Package org.osgi.framework

# Class AdaptPermission

java.lang.Object
java.security.Permission
java.security.BasicPermission
org.osgi.framework.AdaptPermission

All Implemented Interfaces:
  `Serializable`, `Guard`

public final class AdaptPermission extends BasicPermission
A bundle's authority to adapt an object to a type.

`AdaptPermission` has one action: `adapt`.

Author:
  $Id: 9f0866e633ce08566547b4955a2ece54c46944e0 $
See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ADAPT`
The action string `initiate`.

## Constructor Summary

Constructors
Constructor
Description
`AdaptPermission(String filter, String actions)`
Creates a new granted `AdaptPermission` object.
`AdaptPermission(String adaptClass, Bundle adaptableBundle, String actions)`
Creates a new requested `AdaptPermission` object to be used by the code that must perform `checkPermission`.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Determines the equality of two `AdaptPermission` objects.
`String`
`getActions()`
Returns the canonical string representation of the `AdaptPermission` actions.
`int`
`hashCode()`
Returns the hash code value for this object.
`boolean`
`implies(Permission p)`
Determines if the specified permission is implied by this object.
`PermissionCollection`
`newPermissionCollection()`
Returns a new `PermissionCollection` object suitable for storing `AdaptPermission` objects.

### Methods inherited from class java.security.Permission

`checkGuard, getName, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### ADAPT

public static final String ADAPT
The action string `initiate`.

See Also:
  - Constant Field Values

## Constructor Details

### AdaptPermission

public AdaptPermission(String filter, String actions)
Creates a new granted `AdaptPermission` object. This constructor must only be used to create a permission that is going to be checked.

Examples:

     (adaptClass=com.acme.*)
     (&(signer=\*,o=ACME,c=US)(adaptClass=com.acme.*))
     (signer=\*,o=ACME,c=US)

When a signer key is used within the filter expression the signer value must escape the special filter chars ('*', '(', ')').

The name is specified as a filter expression. The filter gives access to the following attributes:

- signer - A Distinguished Name chain used to sign the exporting bundle. Wildcards in a DN are not matched according to the filter string rules, but according to the rules defined for a DN chain.
- location - The location of the exporting bundle.
- id - The bundle ID of the exporting bundle.
- name - The symbolic name of the exporting bundle.
- adaptClass - The name of the type to which an object can be adapted.

Filter attribute names are processed in a case sensitive manner.

Parameters:
  `filter` - A filter expression. Filter attribute names are processed in a case sensitive manner. A special value of `"*"` can be used to match all adaptations.
  `actions` - `adapt`.
Throws:
  `IllegalArgumentException` - If the filter has an invalid syntax.

### AdaptPermission

public AdaptPermission(String adaptClass, Bundle adaptableBundle, String actions)
Creates a new requested `AdaptPermission` object to be used by the code that must perform `checkPermission`. `AdaptPermission` objects created with this constructor cannot be added to an `AdaptPermission` permission collection.

Parameters:
  `adaptClass` - The name of the type to which an object can be adapted.
  `adaptableBundle` - The bundle associated with the object being adapted.
  `actions` - `adapt`.

## Method Details

### implies

public boolean implies(Permission p)
Determines if the specified permission is implied by this object.

This method checks that the filter of the target is implied by the adapt class name of this object. The list of `AdaptPermission` actions must either match or allow for the list of the target object to imply the target `AdaptPermission` action.

Overrides:
  `implies` in class `BasicPermission`
Parameters:
  `p` - The requested permission.
Returns:
  `true` if the specified permission is implied by this object; `false` otherwise.

### getActions

public String getActions()
Returns the canonical string representation of the `AdaptPermission` actions.

Always returns present `AdaptPermission` actions in the following order: `adapt`.

Overrides:
  `getActions` in class `BasicPermission`
Returns:
  Canonical string representation of the `AdaptPermission` actions.

### newPermissionCollection

public PermissionCollection newPermissionCollection()
Returns a new `PermissionCollection` object suitable for storing `AdaptPermission` objects.

Overrides:
  `newPermissionCollection` in class `BasicPermission`
Returns:
  A new `PermissionCollection` object.

### equals

public boolean equals(Object obj)
Determines the equality of two `AdaptPermission` objects. This method checks that specified permission has the same name and `AdaptPermission` actions as this `AdaptPermission` object.

Overrides:
  `equals` in class `BasicPermission`
Parameters:
  `obj` - The object to test for equality with this `AdaptPermission` object.
Returns:
  `true` if `obj` is a `AdaptPermission`, and has the same name and actions as this `AdaptPermission` object; `false` otherwise.

### hashCode

public int hashCode()
Returns the hash code value for this object.

Overrides:
  `hashCode` in class `BasicPermission`
Returns:
  A hash code value for this object.